using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Windows.Forms;
using Baza_Reklam.Classes.Helpers;
using Baza_Reklam.Classes.Interfaces;

namespace Baza_Reklam
{
    public partial class ZamowieniaForm : Form
    {
        private REKLAMADataSet.KLIENCIRow klient;

        private int idZamowienia;

        private REKLAMADataSet.REKLAMADataTable reklamyBezZamowienia;

        private REKLAMADataSetTableAdapters.KLIENCITableAdapter klienciTableAdapter =
            new REKLAMADataSetTableAdapters.KLIENCITableAdapter();

        private SLOWNIKDataSetTableAdapters.AGENCJETableAdapter agencjeTableAdapter =
            new SLOWNIKDataSetTableAdapters.AGENCJETableAdapter();

        private SLOWNIKDataSetTableAdapters.AGENCITableAdapter agenciTableAdapter =
            new SLOWNIKDataSetTableAdapters.AGENCITableAdapter();

        private REKLAMADataSetTableAdapters.UKAZE_SIE_W_NRTableAdapter emisjeTableAdapter =
            new REKLAMADataSetTableAdapters.UKAZE_SIE_W_NRTableAdapter();

        private REKLAMADataSetTableAdapters.FAKTURA_DETAILSTableAdapter fakturyDetailsTableAdapter =
            new REKLAMADataSetTableAdapters.FAKTURA_DETAILSTableAdapter();

        private REKLAMADataSetTableAdapters.WplatyTableAdapter wplatyTableAdapter =
            new REKLAMADataSetTableAdapters.WplatyTableAdapter();

        private REKLAMADataSetTableAdapters.DatyWydanTableAdapter datyWydanTableAdapter =
            new REKLAMADataSetTableAdapters.DatyWydanTableAdapter();

        private SLOWNIKDataSetTableAdapters.Kursy_WalutTableAdapter kursyWalutTableAdapter =
            new SLOWNIKDataSetTableAdapters.Kursy_WalutTableAdapter();

        #region properties

        public REKLAMADataSet.REKLAMADataTable ReklamyBezZamowienia
        {
            get { return reklamyBezZamowienia; }
            set { reklamyBezZamowienia = value; }
        }

        #endregion properties

        public ZamowieniaForm(REKLAMADataSet.KLIENCIRow klient)
        {
            InitializeComponent();
            InitTableAdatpers();

            this.klient = klient;
        }

        public ZamowieniaForm(int idKlienta)
        {
            InitializeComponent();
            InitTableAdatpers();

            klient = klienciTableAdapter.GetDataByCustomerId(idKlienta)[0];
        }

        public ZamowieniaForm(int idKlienta, int idZamowienia)
        {
            InitializeComponent();
            InitTableAdatpers();

            klient = klienciTableAdapter.GetDataByCustomerId(idKlienta)[0];
            this.idZamowienia = idZamowienia;

        }

        private void InitTableAdatpers()
        {
            rEKLAMABindingSource1.DataSource = ReklamyBezZamowienia;
            zamowieniaTableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
            rEKLAMATableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
            fAKTURYTableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
            fakturyDetailsTableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
            klienciTableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
            agencjeTableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
            agenciTableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
            emisjeTableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
            datyWydanTableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
            kursyWalutTableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
            wplatyTableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
        }

        private void ZamowieniaForm_Load(object sender, EventArgs e)
        {
            usunFaktureButton.Enabled = User.Instance().IsKierownik;
            dtpZmianaDaty.Enabled = User.Instance().IsKierownik;
            dtpZmianaDaty.Value = DateTime.Today;
            dtpZmianaDaty.MaxDate = DateTime.Today;

            zamowieniaBindingSource.CurrentChanged += zamowieniaBindingSource_CurrentChanged;

            ReklamyBezZamowienia = rEKLAMATableAdapter.GetDataByCustomerIdandIdZamowienia(klient.CustomerID);
            rEKLAMABindingSource1.DataSource = ReklamyBezZamowienia;
            zamowieniaTableAdapter.FillByIdKlienta(rEKLAMADataSet.zamowienia, klient.CustomerID);

            if (idZamowienia != 0)
            {
                zamowieniaBindingSource.Position = zamowieniaBindingSource.Find("idZamowienia", idZamowienia);
                rEKLAMATableAdapter.FillByIdZamowienia(rEKLAMADataSet.REKLAMA, idZamowienia);
                fAKTURYTableAdapter.FillByIdZamowienia(rEKLAMADataSet.FAKTURY, idZamowienia);
            }
            else
            {
                zamowieniaBindingSource.Position = 0;
            }

            if (klient != null)
            {
                if (klient.IskodKlientaNull())
                {
                    KlientLabel.Text = "BRAK KODU KLIENTA";
                }
                else
                {
                    KlientLabel.Text = "KOD KLIENTA:  " + klient.kodKlienta;
                }
            }
        }

        private void dodajButton_Click(object sender, EventArgs e)
        {
            if (klient.IskodKlientaNull() || klient.kodKlienta.Trim() == string.Empty)
            {
                MessageBox.Show("Uzupełnij kod klienta");
                return;
            }

            AddZamowienieForm azf = new AddZamowienieForm(0, klient.CustomerID);
            if (azf.ShowDialog() == DialogResult.OK)
            {
                //rEKLAMADataSet.zamowienia.Clear();
                //this.zamowieniaTableAdapter.FillByIdKlienta(this.rEKLAMADataSet.zamowienia, klient.CustomerID);
                rEKLAMADataSet.zamowienia.ImportRow(azf.Zamowienia[0]);
                int idZam = azf.Zamowienia[0].idZamowienia;
                zamowieniaBindingSource.Position = zamowieniaBindingSource.Find("idZamowienia", idZam);
                rEKLAMATableAdapter.FillByIdZamowienia(rEKLAMADataSet.REKLAMA, idZam);
                fAKTURYTableAdapter.FillByIdZamowienia(rEKLAMADataSet.FAKTURY, idZam);
            }
        }

        private void edytujButton_Click(object sender, EventArgs e)
        {
            if (zamowieniaBindingSource.Current != null)
            {
                DataRowView z = (DataRowView)zamowieniaBindingSource.Current;
                REKLAMADataSet.zamowieniaRow zamowienie = (REKLAMADataSet.zamowieniaRow)z.Row;

                int idZam = zamowienie.idZamowienia;

                AddZamowienieForm azf = new AddZamowienieForm(idZam, klient.CustomerID);
                if (azf.ShowDialog() == DialogResult.OK)
                {
                    rEKLAMADataSet.zamowienia.Clear();
                    zamowieniaTableAdapter.FillByIdKlienta(rEKLAMADataSet.zamowienia, klient.CustomerID);
                    zamowieniaBindingSource.Position = zamowieniaBindingSource.Find("idZamowienia", idZam);
                }
            }
        }

        private void dodajDoZamButton_Click(object sender, EventArgs e)
        {
            if (zamowieniaBindingSource.Current != null)
            {
                if (rEKLAMADataGridView1.SelectedRows.Count > 0)
                {
                    DataRowView z = (DataRowView)zamowieniaBindingSource.Current;
                    REKLAMADataSet.zamowieniaRow zamowienie = (REKLAMADataSet.zamowieniaRow)z.Row;

                    REKLAMADataSet.REKLAMARow row = (REKLAMADataSet.REKLAMARow)((DataRowView)rEKLAMADataGridView1.SelectedRows[0].DataBoundItem).Row;

                    string s = string.Empty;

                    s = CzyMoznaDodacDoZam(zamowienie,rEKLAMADataSet.REKLAMA, row, s);

                    if (s != string.Empty)
                    {
                        s += "\n Reklamy nie mogą być w obrębie jednego zamówienia";
                        MessageBox.Show(s, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }

                    row.idZamowienia = zamowienie.idZamowienia;

                    if (zamowienie.IsidKontaNull() && !row.IsBrutto_Euro_MianoNull())
                    {
                        // zmiana domyślnego konta do faktury dla EUR
                        if (User.Instance().IdAgencji != 4 & (row.Brutto_Euro_Miano == "EUR"))
                        {
                            if (User.Instance().IdAgencji == 1223940396 | User.Instance().IdAgencji == 1223940398)
                            {
                                zamowienie.idKonta = 3;
                            }
                            else
                            {
                                zamowienie.idKonta = 5;
                            }
                        }
                    }

                    rEKLAMADataSet.REKLAMA.ImportRow(row);
                    ReklamyBezZamowienia.Rows.Remove(row);
                    rEKLAMATableAdapter.Update(rEKLAMADataSet.REKLAMA);
                    zamowieniaTableAdapter.Update(rEKLAMADataSet.zamowienia);
                }
            }
        }

        private string CzyMoznaDodacDoZam(REKLAMADataSet.zamowieniaRow zamowienie,
            REKLAMADataSet.REKLAMADataTable reklamyWZamowieniu,
            REKLAMADataSet.REKLAMARow row, string s)
        {
            if (zamowienie.zafakturowanoWszystko || zamowienie.zafakturowano)
            {
                s += "Zamówienie jest już zafakturowane.";
            }

            //sprawdzenie waluty i VAT
            if (reklamyWZamowieniu.Count > 0)
            {
                REKLAMADataSet.REKLAMARow rek = reklamyWZamowieniu[0];

                if (rek.IsBrutto_Euro_MianoNull() ^ row.IsBrutto_Euro_MianoNull())
                {
                    if ((rek.IsBrutto_Euro_MianoNull() || row.IsBrutto_Euro_MianoNull())
                        ||
                        (rek.Brutto_Euro_Miano != row.Brutto_Euro_Miano))
                    {
                        s += "Reklamy są w różnych walutach. \n";
                    }
                }

                REKLAMADataSet.DatyWydanDataTable t = datyWydanTableAdapter.GetDataByPierwszaEmisjaWZamowieniu(zamowienie.idZamowienia);

                if (t.Rows.Count == 0)
                {
                    s += "Reklama nie ma wybranych emisji. \n";
                }
                else
                {
                    if (!zamowienie.IsdataOstatniejZafakturowanejEmisjiNull())
                    {
                        if (t[0].DATA_W < zamowienie.dataOstatniejZafakturowanejEmisji)
                        {
                            s += "Reklama zawiera emisję na okres, który już został zafakturowany";
                        }
                    }
                }

                if (rek.VAT != row.VAT)
                {
                    s += "Reklamy mają różne stawki VAT. \n";
                }
            }
            return s;
        }

        private void usunZZamButton_Click(object sender, EventArgs e)
        {
            if (zamowieniaBindingSource.Current != null && rEKLAMADataGridView.SelectedRows.Count != 0)
            {
                DataRowView row = (DataRowView)rEKLAMADataGridView.SelectedRows[0].DataBoundItem;

                if (Convert.ToBoolean(row["FAKTURA WYSTAWIONO"]))
                {
                    MessageBox.Show("Reklama ma zafakturowane emisje. Nie można usunąć reklamy.");
                    return;
                }

                row["idZamowienia"] = DBNull.Value;
                row.EndEdit();

                ReklamyBezZamowienia.ImportRow(row.Row);
                rEKLAMADataSet.REKLAMA.Rows.Remove(row.Row);

                rEKLAMATableAdapter.Update(ReklamyBezZamowienia);
                zamowieniaTableAdapter.Update(rEKLAMADataSet.zamowienia);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (zamowieniaBindingSource.Current == null) return;

            try
            {
                Cursor = Cursors.WaitCursor;

                DataRowView z = (DataRowView) zamowieniaBindingSource.Current;
                REKLAMADataSet.zamowieniaRow zamowienie = (REKLAMADataSet.zamowieniaRow) z.Row;

                REKLAMADataSet.KLIENCIRow klientRow =
                    (REKLAMADataSet.KLIENCIRow) klienciTableAdapter.GetDataByCustomerId(zamowienie.idKlienta).Rows[0];

                InitIssueTables(zamowienie);

                string errorMessage = CzyMoznaZafakturowac(zamowienie, klientRow);

                if (errorMessage != string.Empty)
                {
                    MessageBox.Show(errorMessage, "Fakturowanie");
                    Cursor = Cursors.Default;
                    return;
                }

                WystawFakture(zamowienie, klientRow, false);

                RestoreConnections();

                zamowieniaBindingSource.ResetBindings(false);

                fAKTURYBindingSource.MoveLast();
            }
            finally
            {
                Cursor = Cursors.Default;
            }
        }

        private int WystawFakture(REKLAMADataSet.zamowieniaRow zamowienie, REKLAMADataSet.KLIENCIRow klientRow, bool proforma)
        {
            int idNaglowka;
            
            try
            {
                REKLAMADataSet.FAKTURYRow naglowekFaktury = UtworzNaglowekFaktury(zamowienie, klientRow, proforma);
                rEKLAMADataSet.FAKTURY.AddFAKTURYRow(naglowekFaktury);
                PobierzOznaczEmisje(zamowienie, naglowekFaktury);
                UtworzPozycjeFaktury(naglowekFaktury, klientRow);
                DodajWplate(naglowekFaktury);

                zamowienie.zafakturowano = true;
                zamowienie.EndEdit();

                SqlConnection conn = new SqlConnection(ConnString.getConnString().Value);

                fAKTURYTableAdapter.Connection = conn;
                emisjeTableAdapter.Connection = conn;
                zamowieniaTableAdapter.Connection = conn;
                fakturyDetailsTableAdapter.Connection = conn;
                rEKLAMATableAdapter.Connection = conn;
                wplatyTableAdapter.Connection = conn;

                conn.Open();

                SqlTransaction transaction = conn.BeginTransaction();
                fAKTURYTableAdapter.AttachTransaction(transaction);
                emisjeTableAdapter.AttachTransaction(transaction);
                zamowieniaTableAdapter.AttachTransaction(transaction);
                fakturyDetailsTableAdapter.AttachTransaction(transaction);
                rEKLAMATableAdapter.AttachTransaction(transaction);
                wplatyTableAdapter.AttachTransaction(transaction);

                try
                {
                    fAKTURYTableAdapter.Update(rEKLAMADataSet.FAKTURY);
                    idNaglowka = naglowekFaktury.ID_FAKTURY;
                    emisjeTableAdapter.Update(rEKLAMADataSet.UKAZE_SIE_W_NR);
                    fakturyDetailsTableAdapter.Update(rEKLAMADataSet.FAKTURA_DETAILS);
                    wplatyTableAdapter.Update(rEKLAMADataSet.Wplaty);

                    int il = (int)emisjeTableAdapter.iloscNiezafakturowanychEmisjiWZamowieniu(
                        zamowienie.idZamowienia);
                    if (il == 0 && !proforma)
                    {
                        zamowienie.zafakturowanoWszystko = true;
                    }

                    zamowieniaTableAdapter.Update(rEKLAMADataSet.zamowienia);
                    rEKLAMATableAdapter.Update(rEKLAMADataSet.REKLAMA);

                    transaction.Commit();
                    dtpZmianaDaty.Value = DateTime.Today;
                }
                catch (Exception)
                {
                    transaction.Rollback();
                    //conn.Close();
                    rEKLAMADataSet.UKAZE_SIE_W_NR.Clear();
                    rEKLAMADataSet.DatyWydan.Clear();
                    rEKLAMADataSet.FAKTURA_DETAILS.Clear();
                    rEKLAMADataSet.Wplaty.Clear();
                    rEKLAMADataSet.FAKTURY.RemoveFAKTURYRow(naglowekFaktury);
                    fAKTURYBindingSource.ResetBindings(false);
                    fAKTURYDataGridView.Refresh();
                    throw;
                }
                finally
                {
                    if (conn.State == ConnectionState.Open)
                        conn.Close();
                }
            }
            finally
            {
                rEKLAMADataSet.UKAZE_SIE_W_NR.Clear();
                rEKLAMADataSet.DatyWydan.Clear();
                rEKLAMADataSet.FAKTURA_DETAILS.Clear();
                rEKLAMADataSet.Wplaty.Clear();
                fAKTURYBindingSource.ResetBindings(false);
                fAKTURYBindingSource.Sort = "NUMER";
                fAKTURYDataGridView.Refresh();
                zamowieniaBindingSource.ResetBindings(false);
                
            }

            return idNaglowka;
        }

        private void DodajWplate(REKLAMADataSet.FAKTURYRow naglowekFaktury)
        {
            REKLAMADataSet.WplatyRow wplata = rEKLAMADataSet.Wplaty.NewWplatyRow();
            wplata.idFaktury = naglowekFaktury.ID_FAKTURY;
            wplata.idZamowienia = naglowekFaktury.idZamowienia;
            rEKLAMADataSet.Wplaty.AddWplatyRow(wplata);
        }

        private void UtworzPozycjeFaktury(REKLAMADataSet.FAKTURYRow naglowekFaktury, REKLAMADataSet.KLIENCIRow klientRow)
        {
            decimal bruttoWaluta = 0;

            foreach (REKLAMADataSet.UKAZE_SIE_W_NRRow em in rEKLAMADataSet.UKAZE_SIE_W_NR)
            {
                REKLAMADataSet.FAKTURA_DETAILSRow fakturaDetailsRow = rEKLAMADataSet.FAKTURA_DETAILS.NewFAKTURA_DETAILSRow();

                REKLAMADataSet.DatyWydanRow[] dataWydanTable =
                    (REKLAMADataSet.DatyWydanRow[])em.GetChildRows("UKAZE_SIE_W_NR_DatyWydan");
                REKLAMADataSet.DatyWydanRow dataWydania = dataWydanTable[0];

                REKLAMADataSet.REKLAMARow reklama = (REKLAMADataSet.REKLAMARow)em.GetParentRow("REKLAMA_UKAZE_SIE_W_NR");

                fakturaDetailsRow.ROK = Convert.ToInt16(dataWydania.rok);
                fakturaDetailsRow.MIESIAC = Convert.ToInt16(dataWydania.ms);
                fakturaDetailsRow.TYTUL = Convert.ToInt16(dataWydania.idTytulu);
                fakturaDetailsRow.NAZWA_USLUGI = reklama.ID_REKLAMY + " | " + em.Nr_Wydania;
                fakturaDetailsRow.reklamaId = reklama.ReklamaID;
                fakturaDetailsRow.NR_WYDANIA = em.Nr_Wydania;

                fakturaDetailsRow.CENA_JEDN = Math.Round(Convert.ToDecimal(reklama.CENA_JEDN), 2);
                fakturaDetailsRow.ILOSC = 1;
                fakturaDetailsRow.JM = "szt.";

                if (naglowekFaktury.Iswaluta_mianoNull() && klientRow.Country.ToUpper() == "POLSKA")
                {
                    fakturaDetailsRow.UPUST_NETTO = Math.Round(Convert.ToDecimal(reklama.RABAT) * fakturaDetailsRow.CENA_JEDN, 2);
                    fakturaDetailsRow.UPUST_PR = reklama.RABAT;
                    decimal netto = (1 - Convert.ToDecimal(reklama.RABAT)) * fakturaDetailsRow.CENA_JEDN;

                    if (reklama.wyroznienie)
                        netto = Convert.ToDecimal(1 + reklama.wyroznienie_procent) * netto;

                    fakturaDetailsRow.NETTO = Math.Round(netto, 2);
                    fakturaDetailsRow.S_VAT = reklama.VAT;
                    decimal vat = Convert.ToDecimal(reklama.VAT);
                    fakturaDetailsRow.VAT = Convert.ToDecimal(vat * netto);
                    fakturaDetailsRow.BRUTTO = Convert.ToDecimal((1 + vat) * netto);
                }
                else if(naglowekFaktury.Iswaluta_mianoNull() && klientRow.Country.ToUpper() != "POLSKA")
                {
                    decimal vat = Convert.ToDecimal(reklama.VAT);
                    decimal netto = (1 - Convert.ToDecimal(reklama.RABAT)) * fakturaDetailsRow.CENA_JEDN;
                    if (reklama.wyroznienie)
                        netto = Convert.ToDecimal(1 + reklama.wyroznienie_procent) * netto;
                    fakturaDetailsRow.NETTO = Math.Round(netto, 2);
                    fakturaDetailsRow.S_VAT = reklama.VAT;
                    fakturaDetailsRow.BRUTTO = Convert.ToDecimal((1 + vat) * netto);
                    
                    decimal brutto = fakturaDetailsRow.BRUTTO;

                    fakturaDetailsRow.VAT = Convert.ToDecimal(vat * brutto / (1 + vat));

                    fakturaDetailsRow.UPUST_PR = reklama.RABAT;
                    if (fakturaDetailsRow.UPUST_PR != 0)
                        fakturaDetailsRow.UPUST_NETTO = Math.Round(netto/(Convert.ToDecimal(reklama.RABAT) - netto), 2);
                    else
                        fakturaDetailsRow.UPUST_NETTO = 0;

                    fakturaDetailsRow.CENA_JEDN = Convert.ToDecimal(netto + fakturaDetailsRow.UPUST_NETTO);
                }
                else
                {
                    fakturaDetailsRow.BRUTTO = Convert.ToDecimal((reklama.Brutto_Euro / reklama.KROTNOŚĆ) * naglowekFaktury.waluta_kurs);
                    bruttoWaluta += Convert.ToDecimal(reklama.Brutto_Euro / reklama.KROTNOŚĆ);
                    fakturaDetailsRow.S_VAT = reklama.VAT;
                    decimal vat = Convert.ToDecimal(reklama.VAT);
                    decimal brutto = fakturaDetailsRow.BRUTTO;
                    fakturaDetailsRow.VAT = Convert.ToDecimal(vat * brutto / (1 + vat));
                    decimal netto = brutto - fakturaDetailsRow.VAT;
                    fakturaDetailsRow.NETTO = Math.Round(netto, 2);

                    fakturaDetailsRow.UPUST_PR = reklama.RABAT;
                    fakturaDetailsRow.UPUST_NETTO = fakturaDetailsRow.UPUST_PR != 0 ? Math.Round(netto / Convert.ToDecimal(reklama.RABAT) - netto, 2) : 0;

                    fakturaDetailsRow.CENA_JEDN = Convert.ToDecimal(netto + fakturaDetailsRow.UPUST_NETTO);
                }

                fakturaDetailsRow.TYP = 2;
                fakturaDetailsRow.PODTYP = 1;
                fakturaDetailsRow.ID_FAKTURY = naglowekFaktury.ID_FAKTURY;

                if (reklama.wyroznienie)
                {
                    fakturaDetailsRow.wyroznienie = true;
                }

                rEKLAMADataSet.FAKTURA_DETAILS.AddFAKTURA_DETAILSRow(fakturaDetailsRow);
            }

            if (bruttoWaluta != 0)
            {
                naglowekFaktury.waluta_brutto = Math.Round(Convert.ToDouble(bruttoWaluta),2);
                naglowekFaktury.EndEdit();
            }
        }


        private void InitIssueTables(REKLAMADataSet.zamowieniaRow zamowienie)
        {
            emisjeTableAdapter.ClearBeforeFill = false;
            datyWydanTableAdapter.ClearBeforeFill = false;
            rEKLAMADataSet.UKAZE_SIE_W_NR.Clear();
            rEKLAMADataSet.DatyWydan.Clear();

            REKLAMADataSet.DatyWydanDataTable t = datyWydanTableAdapter.GetDataByPierwszaEmisjaWZamowieniu(zamowienie.idZamowienia);
            if (t.Rows.Count <= 0) return;

            DateTime d = t[0].DATA_W;
            //d = zamowienie.IsdataOstatniejZafakturowanejEmisjiNull() ? d : zamowienie.dataOstatniejZafakturowanejEmisji.AddMonths(1);

            List<string> adIds = new List<string>();

            foreach (DataRow r in rEKLAMADataSet.REKLAMA.Rows)
            {
                REKLAMADataSet.REKLAMARow reklama = (REKLAMADataSet.REKLAMARow)r;
                adIds.Add(reklama.ID_REKLAMY);
                switch (zamowienie.rodzajFakturowania)
                {
                    //3m
                    case 1:
                        emisjeTableAdapter.FillByNiezafakturowane3MSRekID(
                            rEKLAMADataSet.UKAZE_SIE_W_NR,
                            reklama.ReklamaID,
                            d);
                        datyWydanTableAdapter.FillByReklamaId(rEKLAMADataSet.DatyWydan, reklama.ReklamaID);
                        break;
                    //calosc
                    case 2:
                        emisjeTableAdapter.FillByNiezafakturowane(rEKLAMADataSet.UKAZE_SIE_W_NR, reklama.ReklamaID);
                        datyWydanTableAdapter.FillByReklamaId(rEKLAMADataSet.DatyWydan, reklama.ReklamaID);
                        break;
                    //1ms
                    default:
                        emisjeTableAdapter.FillByNiezafakturowane1MSrekId(
                            rEKLAMADataSet.UKAZE_SIE_W_NR,
                            reklama.ReklamaID,
                            d);
                        datyWydanTableAdapter.FillByReklamaId(rEKLAMADataSet.DatyWydan, reklama.ReklamaID);
                        break;
                }

                // ustawiane by pozniej blokowac mozliwosc zmiany rabatu itp.
                reklama.FAKTURA_WYSTAWIONO = true;
                reklama.EndEdit();
            }
        }


        private void PobierzOznaczEmisje(REKLAMADataSet.zamowieniaRow zamowienie, REKLAMADataSet.FAKTURYRow naglowekFaktury)
        {
            //InitIssueTables(zamowienie);

            if (zamowienie.IsdataOstatniejZafakturowanejEmisjiNull())
            {
                zamowienie.dataOstatniejZafakturowanejEmisji = DateTime.Today.AddMonths(-1);
            }

            foreach (DataRow r in rEKLAMADataSet.REKLAMA.Rows)
            {
                REKLAMADataSet.REKLAMARow reklama = (REKLAMADataSet.REKLAMARow)r;
                
                foreach (DataRow em in rEKLAMADataSet.UKAZE_SIE_W_NR)
                {
                    REKLAMADataSet.UKAZE_SIE_W_NRRow emisja = (REKLAMADataSet.UKAZE_SIE_W_NRRow)em;
                    emisja.idFaktury = naglowekFaktury.ID_FAKTURY;
                    emisja.zafakturowana = true;

                    if (emisja.ReklamaId == reklama.ReklamaID)
                    {
                        reklama.FAKTURA_WYSTAWIONO = true;

                        if (naglowekFaktury.Iswaluta_mianoNull())
                        {
                            emisja.netto = Convert.ToDecimal(reklama.CENA_JEDN * (1 - reklama.RABAT));
                            if (reklama.wyroznienie)
                            {
                                emisja.netto = Math.Round(Convert.ToDecimal(1 + reklama.wyroznienie_procent) * emisja.netto,2);
                            }
                        }
                        else
                        {
                            decimal temp = Math.Round(
                                Convert.ToDecimal(reklama.Brutto_Euro * naglowekFaktury.waluta_kurs / naglowekFaktury.waluta_przelicznik),2);
                            emisja.netto = Convert.ToDecimal(temp /reklama.KROTNOŚĆ);
                        }

                        emisja.netto = Math.Round(emisja.netto, 2);
                    }

                    REKLAMADataSet.DatyWydanRow[] dataWydanTable =
                                       (REKLAMADataSet.DatyWydanRow[])em.GetChildRows("UKAZE_SIE_W_NR_DatyWydan");
                    REKLAMADataSet.DatyWydanRow dataWydania = dataWydanTable[0];

                    if (dataWydania.DATA_W > zamowienie.dataOstatniejZafakturowanejEmisji)
                    {
                        zamowienie.dataOstatniejZafakturowanejEmisji = dataWydania.DATA_W;
                    }
                }
            }

            zamowienie.EndEdit();
        }

        private REKLAMADataSet.FAKTURYRow UtworzNaglowekFaktury(REKLAMADataSet.zamowieniaRow zamowienie, REKLAMADataSet.KLIENCIRow klientRow, bool proforma)
        {
            SLOWNIKDataSet.AGENCIRow agent = (SLOWNIKDataSet.AGENCIRow)agenciTableAdapter.GetDataByKodAgenta(zamowienie.kodAgenta).Rows[0];
            IInvoiceProvider invoiceProvider = InvoiceProviderFactory.GetInvoiceProviderById(agent.InvoiceProviderId);


            REKLAMADataSet.FAKTURYRow naglowekFaktury = (REKLAMADataSet.FAKTURYRow)rEKLAMADataSet.FAKTURY.NewRow();
            naglowekFaktury.KOREKTA = false;
            naglowekFaktury.idZamowienia = zamowienie.idZamowienia;
            naglowekFaktury.NUMER_ROZ = zamowienie.kodAgenta;
            naglowekFaktury.NUMER = proforma ? zamowienie.nrZamowienia : DbUtils.numerNowejFaktury(naglowekFaktury.NUMER_ROZ, DateTime.Today.Year, invoiceProvider.SystemKsiegowyId);

            naglowekFaktury.NUMER_ROK = DateTime.Today.Year;
            naglowekFaktury.DATA_WYSTAWIENIA = DateTime.Today;

            if (User.Instance().IsKierownik)
            {
                if (dtpZmianaDaty.Value != DateTime.Today)
                {
                    naglowekFaktury.DATA_WYSTAWIENIA = dtpZmianaDaty.Value;
                }
            }

            SLOWNIKDataSet.AGENCJERow agencja = (SLOWNIKDataSet.AGENCJERow)agencjeTableAdapter.GetDataByKodAgenta(zamowienie.kodAgenta).Rows[0];
            naglowekFaktury.ID_SPRZEDAWCY = agencja.Id_agencji;
            
            if (naglowekFaktury.ID_SPRZEDAWCY == 4 || naglowekFaktury.ID_SPRZEDAWCY == 6 ||
                naglowekFaktury.ID_SPRZEDAWCY == 1223940400)
            {
                naglowekFaktury.EKSPORT = true;
            }

            naglowekFaktury.MIEJSCOWOSC_WYSTAWIENIA = agencja.miasto;
            naglowekFaktury.SPRZEDAWCA_ADRES = invoiceProvider.GetAddress(); //agencja.Adres_Fk;
            naglowekFaktury.SPRZEDAWCA_NIP = invoiceProvider.TaxNumber; //agencja.NIP;
            naglowekFaktury.SystemKsiegowyId = Convert.ToByte(invoiceProvider.SystemKsiegowyId);
            

            //SLOWNIKDataSet.AGENCIRow agent = (SLOWNIKDataSet.AGENCIRow)agenciTableAdapter.GetDataByKodAgenta(zamowienie.kodAgenta).Rows[0];
            naglowekFaktury.PODPIS_WYSTAWIL = agent.Imię + " " + agent.Nazwisko;
            naglowekFaktury.DATA_SPRZEDAZY = naglowekFaktury.DATA_WYSTAWIENIA;

            naglowekFaktury.ID_NABYWCY = zamowienie.idKlienta;
            naglowekFaktury.NABYWCA_ADRES = klientRow.Adres_Fkatura;
            naglowekFaktury.NABYWCA_NIP = klientRow.Nip;
            naglowekFaktury.opis = "Faktura za reklamy zgodnie z zamówieniem: " 
                + klientRow.kodKlienta + 
                "/" + zamowienie.nrZamowienia + 
                "/" + zamowienie.kodAgenta + 
                "/" + zamowienie.rokZamowienia;


            naglowekFaktury.SPOSOB_ZAPLATY = FakturaHelper.GetPaymentType(zamowienie.sposobZaplaty);
            naglowekFaktury.TERMIN_ZAPLATY = naglowekFaktury.DATA_SPRZEDAZY.AddDays(zamowienie.czasPlatnosci);
            naglowekFaktury.ZAPLACONO = false;

            naglowekFaktury.FAKTURA_TYP = 2;
            naglowekFaktury.FAKTURA_PODTYP = 1;

            naglowekFaktury.ID_KONTA = Convert.ToInt16(zamowienie.idKonta);
            naglowekFaktury.waluta_kurs = 1d;
            //WALUTOWE
            if (!rEKLAMADataSet.REKLAMA[0].IsBrutto_Euro_MianoNull() &&
                rEKLAMADataSet.REKLAMA[0].Brutto_Euro_Miano != string.Empty)
            {
                //naglowekFaktury.SPRZEDAWCA_NIP = agencja.vies;
                naglowekFaktury.SPRZEDAWCA_NIP = invoiceProvider.TaxCountryPrefix + " " + invoiceProvider.TaxNumber; //agencja.vies;
                naglowekFaktury.NABYWCA_NIP = klientRow.nipKraj + " " + klientRow.Nip;
                naglowekFaktury.waluta_miano = rEKLAMADataSet.REKLAMA[0].Brutto_Euro_Miano;

                DateTime dataPublikacji = naglowekFaktury.DATA_WYSTAWIENIA;

                SLOWNIKDataSet.Kursy_WalutDataTable kurs = kursyWalutTableAdapter.GetDataByDataPublikacji(
                     naglowekFaktury.waluta_miano, dataPublikacji);

                if (kurs.Count == 0)
                {
                    throw new ApplicationException("Błąd przy pobieraniu kursu waluty.");
                }

                naglowekFaktury.waluta_kurs = User.Instance().IdAgencji == 6 ? kurs[0].Kurs_Sredni_Poznan : kurs[0].Kurs_Sredni;
                naglowekFaktury.waluta_kurs_z_dnia = kurs[0].Data_Publikacji;
                naglowekFaktury.waluta_przelicznik = kurs[0].przelicznik;
                naglowekFaktury.waluta_tabela_nr = kurs[0].Numer_Tabeli;
            }
            // jesli klientRow jest zagraniczny a waluta ciagle PLN
            else if (klientRow.Country.ToUpper() != "POLSKA")
            {
                naglowekFaktury.SPRZEDAWCA_NIP = invoiceProvider.TaxCountryPrefix + " " + invoiceProvider.TaxNumber; //agencja.vies;
                naglowekFaktury.NABYWCA_NIP = klientRow.nipKraj + " " + klientRow.Nip;
            }

            naglowekFaktury.EndEdit();
            return naglowekFaktury;
        }

        

        private string CzyMoznaZafakturowac(REKLAMADataSet.zamowieniaRow zamowienie, REKLAMADataSet.KLIENCIRow klientRow)
        {
            string errorMessage = string.Empty;

            errorMessage += zamowienie.zafakturowanoWszystko ? "Nie ma co fakturowac! \n" : "";
            errorMessage += zamowienie.IsrodzajFakturowaniaNull() ? "Nie wybrano sposobu fakturowania. \n" : "";
            errorMessage += zamowienie.IsidKontaNull() ? "Nie wybrano konta. \n" : "";
            errorMessage += zamowienie.IssposobZaplatyNull() ? "Nie wybrano sposobu zapłaty. \n" : "";
            errorMessage += klientRow.IsCountryNull() || string.IsNullOrEmpty(klientRow.Country) ? "Brak państwa klienta. \n" : "";
            errorMessage += klientRow.IsAdres_FkaturaNull() || string.IsNullOrEmpty(klientRow.Adres_Fkatura) ? "Brak adresu faktury klienta. \n" : "";
            errorMessage += klientRow.IsNipNull() || string.IsNullOrEmpty(klientRow.Nip) ? "Brak nipu klienta. \n" : "";

            if (!klientRow.IsCountryNull() && klientRow.Country != "Polska")
                errorMessage += klientRow.IsnipKrajNull() || string.IsNullOrEmpty(klientRow.nipKraj) ? "Brak symbolu kraju w nipie klienta. \n" : "";

            if (rEKLAMADataSet.REKLAMA.Rows.Count <= 0)
            {
                // try to load the ads once again in case something went wrong before...
                rEKLAMATableAdapter.FillByIdZamowienia(rEKLAMADataSet.REKLAMA, zamowienie.idZamowienia);

                if (rEKLAMADataSet.REKLAMA.Rows.Count <= 0)
                    errorMessage += "Proszę dodać przynajmniej jedną reklamę do zamówienia \n";
            }

            if (rEKLAMADataSet.REKLAMA.Select("[ZATWIERDZONO DO DRUKU] = 0").Length > 0)
                errorMessage += "W zamówieniu są reklamy niezatwierdzone do druku \n";

            if (errorMessage.Length > 0)
                return errorMessage;

            if (rEKLAMADataSet.UKAZE_SIE_W_NR.Rows.Count <= 0)
            {
                errorMessage += "Nie znaleziono żadnych emisji do zafakturowania \n";
                return errorMessage;
            }

            REKLAMADataSet.DatyWydanDataTable t = datyWydanTableAdapter.GetDataByPierwszaEmisjaWZamowieniu(zamowienie.idZamowienia);
            if (t.Rows.Count == 0)
                errorMessage += "Nie znaleziono żadnych emisji do zafakturowania \n";

            return errorMessage;
        }


        private void WydrukButton_Click(object sender, EventArgs e)
        {
            if (zamowieniaBindingSource.Current != null)
            {
                DataRowView z = (DataRowView)zamowieniaBindingSource.Current;
                REKLAMADataSet.zamowieniaRow zamowienie = (REKLAMADataSet.zamowieniaRow)z.Row;

                OrderViewer ov = new OrderViewer(zamowienie.idZamowienia, 9);
                ov.ShowDialog();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (fAKTURYBindingSource.Current != null)
            {
                REKLAMADataSet.FAKTURYRow row =
                    (REKLAMADataSet.FAKTURYRow)
                    ((DataRowView)fAKTURYBindingSource.Current).Row;

                if (row.IsidFakturyKorektaNull())
                {
                    FactureViewer fv = new FactureViewer(row.ID_FAKTURY, false);
                    fv.ShowDialog();
                }
                else
                {
                    FactureViewer fv = new FactureViewer(row.ID_FAKTURY, row.idFakturyVAT, row.idFakturyKorekta);
                    fv.ShowDialog();
                }

            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (rEKLAMADataSet.REKLAMA.Rows.Count == 0 && rEKLAMADataSet.FAKTURY.Rows.Count == 0)
            {
                zamowieniaBindingSource.Remove(zamowieniaBindingSource.Current);
                zamowieniaBindingSource.EndEdit();
                zamowieniaTableAdapter.Update(rEKLAMADataSet.zamowienia);
            }
            else
            {
                MessageBox.Show("Nie można usunąć zamówienia.");
            }
        }

        private void korektaButton_Click(object sender, EventArgs e)
        {
            if (fAKTURYBindingSource.Current != null)
            {
                Cursor = Cursors.WaitCursor;

                DataRowView row = (DataRowView)fAKTURYBindingSource.Current;
                REKLAMADataSet.FAKTURYRow faktura = (REKLAMADataSet.FAKTURYRow)row.Row;
                                
                if (Convert.ToBoolean(faktura.KOREKTA))
                {
                    MessageBox.Show("Nie można wystawić korekty do korekty");
                    Cursor = Cursors.Default;
                    return;
                }

                //sprawdzenie czy korekta nie byla juz wystawiona
                if (!faktura.IsID_FK_KORNull())
                {
                    MessageBox.Show("Istnieje już faktura korekta");
                 //   return;
                }

                try
                {
                    REKLAMADataSet.FAKTURYRow naglowekKorekty = utworzNaglowekKorekty(faktura);
                    pobierzEmisjeDoKorekty(faktura);
                    utworzPozycjeFakturyKorekty(naglowekKorekty);

                    if (!faktura.IsID_FK_KORNull())
                    {
                        naglowekKorekty.idFakturyKorekta = faktura.ID_FK_KOR;
                    }
            
                    SqlConnection conn = new SqlConnection(ConnString.getConnString().Value);

                    fAKTURYTableAdapter.Connection = conn;
                    emisjeTableAdapter.Connection = conn;
                    zamowieniaTableAdapter.Connection = conn;
                    fakturyDetailsTableAdapter.Connection = conn;
                    rEKLAMATableAdapter.Connection = conn;

                    conn.Open();

                    SqlTransaction transaction = conn.BeginTransaction();
                    fAKTURYTableAdapter.AttachTransaction(transaction);
                    emisjeTableAdapter.AttachTransaction(transaction);
                    zamowieniaTableAdapter.AttachTransaction(transaction);
                    fakturyDetailsTableAdapter.AttachTransaction(transaction);
                    rEKLAMATableAdapter.AttachTransaction(transaction);

                    try
                    {
                        fAKTURYTableAdapter.Update(rEKLAMADataSet.FAKTURY);

                        faktura.ID_FK_KOR = naglowekKorekty.ID_FAKTURY;
                        faktura.EndEdit();

                        fAKTURYTableAdapter.Update(rEKLAMADataSet.FAKTURY);

                        emisjeTableAdapter.Update(rEKLAMADataSet.UKAZE_SIE_W_NR);
                        fakturyDetailsTableAdapter.Update(rEKLAMADataSet.FAKTURA_DETAILS);
                        zamowieniaTableAdapter.Update(rEKLAMADataSet.zamowienia);

                        transaction.Commit();
                    }
                    catch (Exception)
                    {
                        transaction.Rollback();
                        conn.Close();
                        throw;
                    }
                }
                finally
                {
                    rEKLAMADataSet.UKAZE_SIE_W_NR.Clear();
                    rEKLAMADataSet.DatyWydan.Clear();
                    rEKLAMADataSet.FAKTURA_DETAILS.Clear();
                    fAKTURYBindingSource.ResetBindings(false);
                    fAKTURYDataGridView.Refresh();
                    Cursor = Cursors.Default;
                }
            }

            RestoreConnections();
        }

        private REKLAMADataSet.FAKTURYRow utworzNaglowekKorekty(REKLAMADataSet.FAKTURYRow faktura)
        {
            REKLAMADataSet.FAKTURYRow naglowekKorekty = rEKLAMADataSet.FAKTURY.NewFAKTURYRow();
            naglowekKorekty.KOREKTA = true;
            //  naglowekKorekty.EKSPORT = true;

            naglowekKorekty.idZamowienia = faktura.idZamowienia;
            naglowekKorekty.idFakturyKorekta = faktura.ID_FAKTURY;
            naglowekKorekty.idFakturyVAT = faktura.ID_FAKTURY;

            naglowekKorekty.NUMER_ROZ = faktura.NUMER_ROZ;
            naglowekKorekty.NUMER = FakturaHelper.GetNewCorrectionInvoiceNumber(DateTime.Today.Year, faktura.SystemKsiegowyId);
            naglowekKorekty.NUMER_ROK = DateTime.Today.Year;
            naglowekKorekty.DATA_WYSTAWIENIA = DateTime.Today;

            naglowekKorekty.ID_SPRZEDAWCY = faktura.ID_SPRZEDAWCY;

            if (naglowekKorekty.ID_SPRZEDAWCY == 4 || naglowekKorekty.ID_SPRZEDAWCY == 6 ||
                naglowekKorekty.ID_SPRZEDAWCY == 1223940400)
            {
                naglowekKorekty.EKSPORT = true;
            }

            naglowekKorekty.MIEJSCOWOSC_WYSTAWIENIA = faktura.MIEJSCOWOSC_WYSTAWIENIA;
            naglowekKorekty.SPRZEDAWCA_ADRES = faktura.SPRZEDAWCA_ADRES;
            naglowekKorekty.SPRZEDAWCA_NIP = faktura.SPRZEDAWCA_NIP;
            naglowekKorekty.SystemKsiegowyId = faktura.SystemKsiegowyId;

            naglowekKorekty.PODPIS_WYSTAWIL = faktura.PODPIS_WYSTAWIL;
            naglowekKorekty.DATA_SPRZEDAZY = DateTime.Today;

            naglowekKorekty.ID_NABYWCY = faktura.ID_NABYWCY;
            naglowekKorekty.NABYWCA_ADRES = faktura.NABYWCA_ADRES;
            naglowekKorekty.NABYWCA_NIP = faktura.NABYWCA_NIP;
            naglowekKorekty.TERMIN_ZAPLATY = DateTime.Today.AddDays(7);
            naglowekKorekty.opis = "rezygnacja z emisji reklamy";

            naglowekKorekty.SPOSOB_ZAPLATY = faktura.SPOSOB_ZAPLATY;

            naglowekKorekty.TERMIN_ZAPLATY = faktura.TERMIN_ZAPLATY;
            naglowekKorekty.ZAPLACONO = false;

            naglowekKorekty.FAKTURA_TYP = 2;
            naglowekKorekty.FAKTURA_PODTYP = 1;

            naglowekKorekty.ID_KONTA = faktura.ID_KONTA;

            if (!faktura.Iswaluta_mianoNull())
            {
                naglowekKorekty.SPRZEDAWCA_NIP = faktura.SPRZEDAWCA_NIP;
                naglowekKorekty.NABYWCA_NIP = faktura.NABYWCA_NIP;
                naglowekKorekty.waluta_miano = faktura.waluta_miano;

                naglowekKorekty.waluta_kurs = faktura.waluta_kurs;
                naglowekKorekty.waluta_kurs_z_dnia = faktura.waluta_kurs_z_dnia;
                naglowekKorekty.waluta_przelicznik = faktura.waluta_przelicznik;
                naglowekKorekty.waluta_tabela_nr = faktura.waluta_tabela_nr;
            }

            rEKLAMADataSet.FAKTURY.AddFAKTURYRow(naglowekKorekty);

            return naglowekKorekty;
        }


        private void pobierzEmisjeDoKorekty(REKLAMADataSet.FAKTURYRow naglowekFaktury)
        {
            emisjeTableAdapter.ClearBeforeFill = false;
            datyWydanTableAdapter.ClearBeforeFill = false;

            emisjeTableAdapter.FillByIdFaktury(rEKLAMADataSet.UKAZE_SIE_W_NR, naglowekFaktury.ID_FAKTURY);
            datyWydanTableAdapter.FillByIdFaktury(rEKLAMADataSet.DatyWydan, naglowekFaktury.ID_FAKTURY);
        }

        private void utworzPozycjeFakturyKorekty(REKLAMADataSet.FAKTURYRow naglowekFaktury)
        {
            decimal brutto_waluta = 0;

            foreach (REKLAMADataSet.UKAZE_SIE_W_NRRow em in rEKLAMADataSet.UKAZE_SIE_W_NR)
            {
                if (em.status != 2)
                {
                    REKLAMADataSet.FAKTURA_DETAILSRow fakturaDetailsRow = rEKLAMADataSet.FAKTURA_DETAILS.NewFAKTURA_DETAILSRow();

                    REKLAMADataSet.DatyWydanRow[] dataWydanTable =
                        (REKLAMADataSet.DatyWydanRow[])em.GetChildRows("UKAZE_SIE_W_NR_DatyWydan");
                    REKLAMADataSet.DatyWydanRow dataWydania = dataWydanTable[0];

                    REKLAMADataSet.REKLAMARow reklama = (REKLAMADataSet.REKLAMARow)em.GetParentRow("REKLAMA_UKAZE_SIE_W_NR");
                                       
                    fakturaDetailsRow.ROK = Convert.ToInt16(dataWydania.rok);
                    fakturaDetailsRow.MIESIAC = Convert.ToInt16(dataWydania.ms);
                    fakturaDetailsRow.TYTUL = Convert.ToInt16(dataWydania.idTytulu);
                    fakturaDetailsRow.NAZWA_USLUGI = reklama.ID_REKLAMY + " | " + em.Nr_Wydania;
                    fakturaDetailsRow.reklamaId = reklama.ReklamaID;
                    fakturaDetailsRow.NR_WYDANIA = em.Nr_Wydania;

                    fakturaDetailsRow.CENA_JEDN = Convert.ToDecimal(reklama.CENA_JEDN);
                    fakturaDetailsRow.ILOSC = 1;
                    fakturaDetailsRow.JM = "szt.";

                    if (naglowekFaktury.Iswaluta_mianoNull())
                    {
                        fakturaDetailsRow.UPUST_NETTO = Convert.ToDecimal(reklama.RABAT) * fakturaDetailsRow.CENA_JEDN;
                        fakturaDetailsRow.UPUST_PR = reklama.RABAT;
                        decimal netto = (1 - Convert.ToDecimal(reklama.RABAT)) * fakturaDetailsRow.CENA_JEDN;
                        fakturaDetailsRow.NETTO = netto;
                        fakturaDetailsRow.S_VAT = reklama.VAT;
                        decimal _vat = Convert.ToDecimal(reklama.VAT);
                        fakturaDetailsRow.VAT = Convert.ToDecimal(Math.Round(_vat * netto, 2));
                        fakturaDetailsRow.BRUTTO = Convert.ToDecimal(Math.Round((1 + _vat) * netto, 2));
                    }
                    else
                    {
                        //int krotnosc = this.rEKLAMADataSet.UKAZE_SIE_W_NR.PoliczAktywne(reklama.ReklamaID);

                        fakturaDetailsRow.BRUTTO = Convert.ToDecimal((reklama.Brutto_Euro / reklama.KROTNOŚĆ) * naglowekFaktury.waluta_kurs);
                        brutto_waluta += Convert.ToDecimal(reklama.Brutto_Euro / reklama.KROTNOŚĆ);
                        fakturaDetailsRow.S_VAT = reklama.VAT;
                        decimal _vat = Convert.ToDecimal(reklama.VAT);
                        decimal brutto = fakturaDetailsRow.BRUTTO;
                        fakturaDetailsRow.VAT = Convert.ToDecimal(Math.Round(_vat * brutto / (1 + _vat), 2));
                        decimal netto = brutto - fakturaDetailsRow.VAT;
                        fakturaDetailsRow.NETTO = netto;
                        fakturaDetailsRow.UPUST_PR = reklama.RABAT;
                        if (fakturaDetailsRow.UPUST_PR != 0)
                        {
                            fakturaDetailsRow.UPUST_NETTO = netto / Convert.ToDecimal(reklama.RABAT) - netto;
                        }
                        else
                        {
                            fakturaDetailsRow.UPUST_NETTO = 0;
                        }

                        fakturaDetailsRow.CENA_JEDN = Convert.ToDecimal(netto + fakturaDetailsRow.UPUST_NETTO);
                    }

                    fakturaDetailsRow.TYP = 2;
                    fakturaDetailsRow.PODTYP = 1;
                    fakturaDetailsRow.ID_FAKTURY = naglowekFaktury.ID_FAKTURY;

                    if (reklama.wyroznienie)
                    {
                        fakturaDetailsRow.wyroznienie = true;
                    }

                    rEKLAMADataSet.FAKTURA_DETAILS.AddFAKTURA_DETAILSRow(fakturaDetailsRow);
                }
            }

            if (brutto_waluta != 0)
            {
                naglowekFaktury.waluta_brutto = Math.Round(Convert.ToDouble(brutto_waluta),2);
                naglowekFaktury.EndEdit();
            }
        }

        private void fAKTURYDataGridView_DataBindingComplete(object sender, DataGridViewBindingCompleteEventArgs e)
        {
            foreach (DataGridViewRow row in fAKTURYDataGridView.Rows)
            {
                DataRowView r = (DataRowView)row.DataBoundItem;
                REKLAMADataSet.FAKTURYRow f = (REKLAMADataSet.FAKTURYRow)r.Row;
                if (!f.IsidFakturyKorektaNull())
                {
                    row.DefaultCellStyle.ForeColor = Color.Red;
                }
            }
        }

        private void korektaDoExportButton_Click(object sender, EventArgs e)
        {
            if (fAKTURYBindingSource.Current != null)
            {
                Cursor = Cursors.WaitCursor;

                DataRowView row = (DataRowView)fAKTURYBindingSource.Current;
                REKLAMADataSet.FAKTURYRow faktura = (REKLAMADataSet.FAKTURYRow)row.Row;

                if (Convert.ToBoolean(faktura.KOREKTA) && faktura.EKSPORT)
                {
                    faktura.EKSPORT = false;
                    fAKTURYBindingSource.EndEdit();
                    fAKTURYTableAdapter.Update(rEKLAMADataSet.FAKTURY);
                }

                Cursor = Cursors.Default;
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (fAKTURYBindingSource.Current != null)
            {
                DataRowView row = (DataRowView)fAKTURYBindingSource.Current;
                REKLAMADataSet.FAKTURYRow f = (REKLAMADataSet.FAKTURYRow)row.Row;

                REKLAMADataSetTableAdapters.WplatyTableAdapter wplaty = new REKLAMADataSetTableAdapters.WplatyTableAdapter();
                wplaty.Connection.ConnectionString = ConnString.getConnString().Value;
                REKLAMADataSet.WplatyDataTable table = wplaty.GetDataByIdFaktury(f.ID_FAKTURY);

                PaymentForm2 pf2 = table.Count == 0 ? new PaymentForm2(0, f.ID_FAKTURY) : new PaymentForm2(table[0].idWplaty, f.ID_FAKTURY);

                pf2.ShowDialog();
            }
        }

        private void reklama1Button_Click(object sender, EventArgs e)
        {
            if (rEKLAMABindingSource.Current != null)
            {
                DataRowView row = (DataRowView)rEKLAMABindingSource.Current;
                REKLAMADataSet.REKLAMARow reklama = (REKLAMADataSet.REKLAMARow)row.Row;
                int id = reklama.ReklamaID;

                OrderDetails.getOrderDetails().PokazSzczegolyZamowienia(id);

                if (OrderDetails.getOrderDetails().ShowDialog() == DialogResult.OK)
                {
                    rEKLAMATableAdapter.FillByIdZamowienia(rEKLAMADataSet.REKLAMA, reklama.idZamowienia);
                    rEKLAMABindingSource.Position = rEKLAMABindingSource.Find("reklamaId", id);
                }
            }
        }

        private void reklama2Button_Click(object sender, EventArgs e)
        {
            if (rEKLAMABindingSource1.Current != null)
            {
                DataRowView row = (DataRowView)rEKLAMABindingSource1.Current;
                REKLAMADataSet.REKLAMARow reklama = (REKLAMADataSet.REKLAMARow)row.Row;
                int id = reklama.ReklamaID;

                OrderDetails.getOrderDetails().PokazSzczegolyZamowienia(id);
                if (OrderDetails.getOrderDetails().ShowDialog() == DialogResult.OK)
                {
                    ReklamyBezZamowienia = rEKLAMATableAdapter.GetDataByCustomerIdandIdZamowienia(klient.CustomerID);
                    rEKLAMABindingSource1.DataSource = ReklamyBezZamowienia;
                    rEKLAMABindingSource1.Position = rEKLAMABindingSource1.Find("reklamaId", id);
                }
            }
        }

        private void fAKTURYBindingSource_CurrentChanged(object sender, EventArgs e)
        {
            if (fAKTURYBindingSource.Current == null) return;

            wplataButton.Enabled = !Convert.ToBoolean(((REKLAMADataSet.FAKTURYRow)((DataRowView)fAKTURYBindingSource.Current).Row).KOREKTA);
        }

        private void zamowieniaBindingSource_CurrentChanged(object sender, EventArgs e)
        {
            if (zamowieniaBindingSource.Current == null) return;

            RestoreConnections();
            
            DataRowView z = (DataRowView) zamowieniaBindingSource.Current;
            REKLAMADataSet.zamowieniaRow zamowienie = (REKLAMADataSet.zamowieniaRow) z.Row;
            
            rEKLAMATableAdapter.FillByIdZamowienia(rEKLAMADataSet.REKLAMA, zamowienie.idZamowienia);
            fAKTURYTableAdapter.FillByIdZamowienia(rEKLAMADataSet.FAKTURY, zamowienie.idZamowienia);

            dodajDoZamButton.Enabled = !zamowienie.zafakturowanoWszystko;
            usunZZamButton.Enabled = !zamowienie.zafakturowanoWszystko;
            fakturujButton.Enabled = !zamowienie.zafakturowanoWszystko;

            if (!zamowienie.IsdataOstatniejZafakturowanejEmisjiNull())
            {
                DateTime data = zamowienie.dataOstatniejZafakturowanejEmisji;
                DateTime dzis = DateTime.Today;

                if ((dzis.Year > data.Year) ||
                    (dzis.Year == data.Year & dzis.Month > data.Month))
                {
                    fakturujButton.Enabled = true;
                }
                else
                {
                    fakturujButton.Enabled = false;
                }
            }
        }

        private void usunFaktureButton_Click(object sender, EventArgs e)
        {
            if (fAKTURYBindingSource.Current == null) return;
            DialogResult dialog = MessageBox.Show("Czy na pewno chcesz usunąć fakturę?",
                                                  "Faktura - usuwanie",
                                                  MessageBoxButtons.YesNo,
                                                  MessageBoxIcon.Question);

            if (dialog != DialogResult.Yes) return;


            Cursor = Cursors.WaitCursor;

            REKLAMADataSet.FAKTURYRow faktura = (REKLAMADataSet.FAKTURYRow)((DataRowView)fAKTURYBindingSource.Current).Row;

            //jezeli jest korekta do tej faktury to nie mozna jej usunac
            if (!Convert.ToBoolean(faktura.KOREKTA) && !faktura.IsID_FK_KORNull())
            {
                MessageBox.Show("Istnieje korekta. Nie można usunąć faktury");
                return;
            }


            //jezeli jest korekta do tej korekty to nie mozna jej usunac
            if (Convert.ToBoolean(faktura.KOREKTA) && fAKTURYBindingSource.Find("idFakturyKorekta", faktura.ID_FAKTURY) > -1)
            {
                MessageBox.Show("Nie można usunąć faktury");
                return;
            }

            if (Convert.ToBoolean(faktura.KOREKTA))
                usunKorekte(faktura);
            else
                UsunFakture(faktura);

            Cursor = Cursors.Default;
        }

        private void usunKorekte(REKLAMADataSet.FAKTURYRow korekta)
        {
            int idKorekty = korekta.ID_FAKTURY;
            int idKorygowanejFaktury = korekta.idFakturyKorekta;
            int idZam = korekta.idZamowienia;

              int i = fAKTURYBindingSource.Find("ID_FK_KOR",idKorekty);
         
            REKLAMADataSet.FAKTURYRow korygowanaFaktura = (REKLAMADataSet.FAKTURYRow)
                ((DataRowView)fAKTURYBindingSource.List[i]).Row;

             int j = fAKTURYBindingSource.Find("ID_FAKTURY",idKorygowanejFaktury);

             if (j > -1 && i!= j)
             {
                 REKLAMADataSet.FAKTURYRow poprzedniaKorekta = (REKLAMADataSet.FAKTURYRow)
                     ((DataRowView)fAKTURYBindingSource.List[j]).Row;

                 korygowanaFaktura.ID_FK_KOR = poprzedniaKorekta.ID_FAKTURY;
             }
             else
             {
                 korygowanaFaktura.SetID_FK_KORNull();
             }
            
            fAKTURYBindingSource.EndEdit();

            SqlConnection conn = new SqlConnection(ConnString.getConnString().Value);

            fAKTURYTableAdapter.Connection = conn;
            fakturyDetailsTableAdapter.Connection = conn;

            conn.Open();
            SqlTransaction transaction = conn.BeginTransaction();

            fAKTURYTableAdapter.AttachTransaction(transaction);
            fakturyDetailsTableAdapter.AttachTransaction(transaction);

            try
            {
                fAKTURYTableAdapter.Update(rEKLAMADataSet.FAKTURY);
                fAKTURYTableAdapter.Delete(idKorekty);
                fakturyDetailsTableAdapter.Delete(idKorekty);

                transaction.Commit();
            }
            catch (Exception)
            {
                transaction.Rollback();
                throw;
            }
            finally
            {
                fAKTURYTableAdapter.FillByIdZamowienia(rEKLAMADataSet.FAKTURY, idZam);
                conn.Close();
            }
        }

        private void UsunFakture(REKLAMADataSet.FAKTURYRow faktura)
        {
            int idFakt = faktura.ID_FAKTURY;
            int idZam = faktura.idZamowienia;
            bool zmienReklamyOrazZamowienie = false;

            if (fAKTURYBindingSource.List.Count == 1)
            {
                zmienReklamyOrazZamowienie = true;
            }

            emisjeTableAdapter.ClearBeforeFill = false;
            emisjeTableAdapter.FillByIdFaktury(rEKLAMADataSet.UKAZE_SIE_W_NR, idFakt);

            foreach (DataRow r in rEKLAMADataSet.UKAZE_SIE_W_NR.Rows)
            {
                REKLAMADataSet.UKAZE_SIE_W_NRRow row = (REKLAMADataSet.UKAZE_SIE_W_NRRow)r;

                row.SetidFakturyNull();
                row.netto = 0;
                row.zafakturowana = false;
                row.EndEdit();
            }

            DataRowView zam = (DataRowView)zamowieniaBindingSource.Current;
            REKLAMADataSet.zamowieniaRow zamowienie =
                (REKLAMADataSet.zamowieniaRow)zam.Row;
         
            if (zmienReklamyOrazZamowienie)
            {
                foreach (DataRow r in rEKLAMADataSet.REKLAMA.Rows)
                {
                    REKLAMADataSet.REKLAMARow reklama = (REKLAMADataSet.REKLAMARow)r;
                    reklama.FAKTURA_WYSTAWIONO = false;
                    reklama.EndEdit();
                }
                zamowienie.zafakturowano = false;
            }
            //przy usuwaniu faktury zawsze ustaw to pole na false, poniewaz nie pozwala wystawic faktury
            zamowienie.zafakturowanoWszystko = false;
            zamowienie.SetdataOstatniejZafakturowanejEmisjiNull();
            zamowienie.EndEdit();
           
            SqlConnection conn = new SqlConnection(ConnString.getConnString().Value);

            fAKTURYTableAdapter.Connection = conn;
            emisjeTableAdapter.Connection = conn;
            zamowieniaTableAdapter.Connection = conn;
            fakturyDetailsTableAdapter.Connection = conn;
            rEKLAMATableAdapter.Connection = conn;
            wplatyTableAdapter.Connection = conn;

            conn.Open();
            SqlTransaction transaction = conn.BeginTransaction();

            fAKTURYTableAdapter.AttachTransaction(transaction);
            emisjeTableAdapter.AttachTransaction(transaction);
            zamowieniaTableAdapter.AttachTransaction(transaction);
            fakturyDetailsTableAdapter.AttachTransaction(transaction);
            rEKLAMATableAdapter.AttachTransaction(transaction);
            wplatyTableAdapter.AttachTransaction(transaction);

            try
            {
                fAKTURYTableAdapter.Delete(idFakt);
                fakturyDetailsTableAdapter.Delete(idFakt);
                wplatyTableAdapter.Delete(idFakt);
                emisjeTableAdapter.Update(rEKLAMADataSet.UKAZE_SIE_W_NR);
                zamowieniaTableAdapter.Update(rEKLAMADataSet.zamowienia);
                rEKLAMATableAdapter.Update(rEKLAMADataSet.REKLAMA);

                transaction.Commit();
            }
            catch
            {
                transaction.Rollback();
                throw;
            }
            finally
            {
                rEKLAMADataSet.UKAZE_SIE_W_NR.Clear();
                fAKTURYTableAdapter.FillByIdZamowienia(rEKLAMADataSet.FAKTURY, idZam);
                conn.Close();
            }
        }

        private void proformaButton_Click(object sender, EventArgs e)
        {
            if (zamowieniaBindingSource.Current == null) return;

            Cursor = Cursors.WaitCursor;

            DataRowView z = (DataRowView) zamowieniaBindingSource.Current;
            REKLAMADataSet.zamowieniaRow zamowienie = (REKLAMADataSet.zamowieniaRow) z.Row;

            REKLAMADataSet.KLIENCIRow _klient =
                (REKLAMADataSet.KLIENCIRow) klienciTableAdapter.GetDataByCustomerId(zamowienie.idKlienta).Rows[0];

            InitIssueTables(zamowienie);

            string errorMessage = CzyMoznaZafakturowac(zamowienie, _klient);

            if (errorMessage != string.Empty)
            {
                MessageBox.Show(errorMessage, "Fakturowanie - Proforma");
                Cursor = Cursors.Default;
                return;
            }

            int id = 0;
            try
            {
                id = WystawFakture(zamowienie, _klient, true);
                FactureViewer fv = new FactureViewer(id, true, _klient.kodKlienta);
                fv.ShowDialog();
            }
            finally
            {
                DataRow[] rows = rEKLAMADataSet.FAKTURY.Select("id_faktury=" + id);
                if (rows.Length > 0)
                    UsunFakture((REKLAMADataSet.FAKTURYRow) rows[0]);
                
                RestoreConnections();
                Cursor = Cursors.Default;
            }
        }

        private void RestoreConnections()
        {
            fAKTURYTableAdapter.Connection = new SqlConnection(ConnString.getConnString().Value);
            emisjeTableAdapter.Connection = new SqlConnection(ConnString.getConnString().Value);
            zamowieniaTableAdapter.Connection = new SqlConnection(ConnString.getConnString().Value);
            fakturyDetailsTableAdapter.Connection = new SqlConnection(ConnString.getConnString().Value);
            rEKLAMATableAdapter.Connection = new SqlConnection(ConnString.getConnString().Value);
            wplatyTableAdapter.Connection = new SqlConnection(ConnString.getConnString().Value);
        }
    }
}